blob: a6e378f89cf589a20b7909b5ec80610fd43c37a0 [file] [log] [blame]
Peter Tysera5a27b92009-12-06 23:58:28 -06001#!/bin/bash
Wolfgang Denk7b74fec2010-10-17 12:26:48 +02002# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
Wolfgang Denk1234ce72013-06-21 10:22:36 +02005#
6# SPDX-License-Identifier: GPL-2.0+
Mike Frysingered639982011-04-21 22:01:43 +00007
8usage()
9{
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
Masahiro Yamada8fd32a22013-11-21 19:06:58 +090021 -b BOARD, --board BOARD Build all boards with board name BOARD
Marek Vasutcc3e1cb2011-12-02 21:32:03 +000022 -l, --list List all targets to be built
Marek Vasut4f21ade2012-03-05 15:10:51 +000023 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
Kim Phillips568ea612012-09-27 14:57:34 +000025 -C, --check Enable build checking
Joe Hershberger76c17542012-10-30 15:55:21 +000026 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
Mike Frysingered639982011-04-21 22:01:43 +000028 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
Wolfgang Denk7b74fec2010-10-17 12:26:48 +020035
Mike Frysingered639982011-04-21 22:01:43 +000036 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
Allen Martin4b29aed2013-01-29 14:34:58 +000041 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
Wolfgang Denkec7fbf52013-10-04 17:43:24 +020042 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
Mike Frysingered639982011-04-21 22:01:43 +000044 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
Andy Flemingaf1cc312012-04-24 19:33:51 +000046 BUILD_NBUILDS number of parallel targets (default: 1)
Mike Frysingered639982011-04-21 22:01:43 +000047
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61}
62
Masahiro Yamada8fd32a22013-11-21 19:06:58 +090063SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
Wolfgang Denk7b74fec2010-10-17 12:26:48 +020065
66# Option processing based on util-linux-2.13/getopt-parse.bash
67
Wolfgang Denk1136f692010-10-27 22:48:30 +020068# Note that we use `"$@"' to let each command-line parameter expand to a
Wolfgang Denk7b74fec2010-10-17 12:26:48 +020069# separate word. The quotes around `$@' are essential!
70# We need TEMP as the `eval set --' would nuke the return value of
71# getopt.
72TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
Mike Frysingered639982011-04-21 22:01:43 +000075[ $? != 0 ] && usage 1
Wolfgang Denk7b74fec2010-10-17 12:26:48 +020076
77# Note the quotes around `$TEMP': they are essential!
78eval set -- "$TEMP"
79
80SELECTED=''
Marek Vasutcc3e1cb2011-12-02 21:32:03 +000081ONLY_LIST=''
Marek Vasut4f21ade2012-03-05 15:10:51 +000082PRINT_MAINTS=''
83MAINTAINERS_ONLY=''
Joe Hershberger76c17542012-10-30 15:55:21 +000084CONTINUE=''
85REBUILD_ERRORS=''
Wolfgang Denk7b74fec2010-10-17 12:26:48 +020086
87while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
Allen Martin43e92742012-08-31 08:30:06 +0000101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200102 else
Allen Martin43e92742012-08-31 08:30:06 +0000103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200111 else
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
Masahiro Yamada8fd32a22013-11-21 19:06:58 +0900125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
Kim Phillips568ea612012-09-27 14:57:34 +0000136 -C|--check)
137 CHECK='C=1'
138 shift ;;
Joe Hershberger76c17542012-10-30 15:55:21 +0000139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
Marek Vasutcc3e1cb2011-12-02 21:32:03 +0000145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
Marek Vasut4f21ade2012-03-05 15:10:51 +0000148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
Mike Frysingered639982011-04-21 22:01:43 +0000157 -h|--help)
158 usage ;;
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164done
Masahiro Yamada553b1fc2014-07-22 11:19:08 +0900165
166GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
168 exit 1
169}
170
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200171# echo "Remaining arguments:"
172# for arg do echo '--> '"\`$arg'" ; done
173
Masahiro Yamadad2458ed2014-08-22 14:33:40 +0900174tools/genboardscfg.py || {
175 echo "Failed to generate boards.cfg" >&2
176 exit 1
177}
Masahiro Yamada49e2c3c2014-07-30 14:08:21 +0900178
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200179FILTER="\$1 !~ /^#/"
180[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
Masahiro Yamada8fd32a22013-11-21 19:06:58 +0900184[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200185
186if [ "$SELECTED" ] ; then
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200187 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
Peter Tyser2f887602010-10-29 17:59:06 -0500188
189 # Make sure some boards from boards.cfg are actually found
190 if [ -z "$SELECTED" ] ; then
191 echo "Error: No boards selected, invalid arguments"
192 exit 1
193 fi
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200194fi
195
196#########################################################################
197
Peter Tyser23240d22009-09-21 12:04:32 -0500198# Print statistics when we exit
199trap exit 1 2 3 15
200trap print_stats 0
201
Wolfgang Denkde5d6602008-12-09 00:39:08 +0100202# Determine number of CPU cores if no default was set
203: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
204
205if [ "$BUILD_NCPUS" -gt 1 ]
206then
Peter Tyser8a07f9a2009-09-21 12:04:33 -0500207 JOBS="-j $((BUILD_NCPUS + 1))"
Wolfgang Denkde5d6602008-12-09 00:39:08 +0100208else
209 JOBS=""
210fi
211
Marian Balakowiczd62379d2006-09-01 19:49:50 +0200212if [ "${MAKEALL_LOGDIR}" ] ; then
213 LOG_DIR=${MAKEALL_LOGDIR}
214else
215 LOG_DIR="LOG"
216fi
Stefan Roese42fbddd2006-09-07 11:51:23 +0200217
Andy Flemingaf1cc312012-04-24 19:33:51 +0000218: ${BUILD_NBUILDS:=1}
219BUILD_MANY=0
220
221if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
222 BUILD_MANY=1
223 : ${BUILD_DIR:=./build}
224 mkdir -p "${BUILD_DIR}/ERR"
225 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
Marian Balakowiczd62379d2006-09-01 19:49:50 +0200226fi
227
Andy Flemingaf1cc312012-04-24 19:33:51 +0000228: ${BUILD_DIR:=.}
229
230OUTPUT_PREFIX="${BUILD_DIR}"
231
232[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
Joe Hershberger76c17542012-10-30 15:55:21 +0000233if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234 find "${LOG_DIR}/" -type f -exec rm -f {} +
235fi
wdenk7ebf7442002-11-02 23:17:16 +0000236
237LIST=""
238
Peter Tyser23240d22009-09-21 12:04:32 -0500239# Keep track of the number of builds and errors
240ERR_CNT=0
241ERR_LIST=""
Joe Hershberger67fc0592012-05-21 04:49:38 +0000242WRN_CNT=0
243WRN_LIST=""
Peter Tyser23240d22009-09-21 12:04:32 -0500244TOTAL_CNT=0
Joe Hershberger76c17542012-10-30 15:55:21 +0000245SKIP_CNT=0
Andy Flemingaf1cc312012-04-24 19:33:51 +0000246CURRENT_CNT=0
247OLDEST_IDX=1
Peter Tysera5a27b92009-12-06 23:58:28 -0600248RC=0
Peter Tyser23240d22009-09-21 12:04:32 -0500249
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400250# Helper funcs for parsing boards.cfg
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900251targets_by_field()
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400252{
Masahiro Yamada890a4e82013-10-21 11:11:27 +0900253 field=$1
254 regexp=$2
255
256 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
257 boards.cfg
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400258}
Masahiro Yamada890a4e82013-10-21 11:11:27 +0900259
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900260targets_by_arch() { targets_by_field 2 "$@" ; }
261targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262targets_by_soc() { targets_by_field 4 "$@" ; }
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400263
wdenk7ebf7442002-11-02 23:17:16 +0000264#########################################################################
wdenk359733b2003-03-31 17:27:09 +0000265## MPC5xx Systems
266#########################################################################
267
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900268LIST_5xx="$(targets_by_cpu mpc5xx)"
wdenk359733b2003-03-31 17:27:09 +0000269
270#########################################################################
wdenk21136db2003-07-16 21:53:01 +0000271## MPC5xxx Systems
272#########################################################################
273
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900274LIST_5xxx="$(targets_by_cpu mpc5xxx)"
wdenk21136db2003-07-16 21:53:01 +0000275
276#########################################################################
Rafal Jaworowskid3a02c32007-07-27 14:43:59 +0200277## MPC512x Systems
278#########################################################################
279
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900280LIST_512x="$(targets_by_cpu mpc512x)"
Rafal Jaworowskid3a02c32007-07-27 14:43:59 +0200281
282#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000283## MPC8xx Systems
284#########################################################################
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400285
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900286LIST_8xx="$(targets_by_cpu mpc8xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000287
288#########################################################################
289## PPC4xx Systems
290#########################################################################
291
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900292LIST_4xx="$(targets_by_cpu ppc4xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000293
294#########################################################################
wdenk541a76d2003-05-03 15:50:43 +0000295## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk7ebf7442002-11-02 23:17:16 +0000296#########################################################################
297
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900298LIST_8260="$(targets_by_cpu mpc8260)"
wdenk7ebf7442002-11-02 23:17:16 +0000299
300#########################################################################
Eran Liberty9095d4a2005-07-28 10:08:46 -0500301## MPC83xx Systems (includes 8349, etc.)
302#########################################################################
303
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900304LIST_83xx="$(targets_by_cpu mpc83xx)"
Eran Liberty9095d4a2005-07-28 10:08:46 -0500305
306#########################################################################
wdenk9c53f402003-10-15 23:53:47 +0000307## MPC85xx Systems (includes 8540, 8560 etc.)
308#########################################################################
309
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900310LIST_85xx="$(targets_by_cpu mpc85xx)"
wdenk9c53f402003-10-15 23:53:47 +0000311
312#########################################################################
Jon Loeliger5fe34492007-05-23 14:09:46 -0500313## MPC86xx Systems
314#########################################################################
315
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900316LIST_86xx="$(targets_by_cpu mpc86xx)"
Jon Loeliger5fe34492007-05-23 14:09:46 -0500317
318#########################################################################
Wolfgang Denk66549bd2008-04-20 15:35:52 -0700319## PowerPC groups
320#########################################################################
321
322LIST_TSEC=" \
323 ${LIST_83xx} \
324 ${LIST_85xx} \
325 ${LIST_86xx} \
326"
327
Stefan Roese88fbf932010-04-15 16:07:28 +0200328LIST_powerpc=" \
Kim Phillips8c0c8932007-08-10 15:34:48 -0500329 ${LIST_5xx} \
Jean-Christophe PLAGNIOL-VILLARD0912d312007-11-25 22:39:25 +0100330 ${LIST_512x} \
Kim Phillips8c0c8932007-08-10 15:34:48 -0500331 ${LIST_5xxx} \
332 ${LIST_8xx} \
Kim Phillips8c0c8932007-08-10 15:34:48 -0500333 ${LIST_824x} \
334 ${LIST_8260} \
335 ${LIST_83xx} \
336 ${LIST_85xx} \
337 ${LIST_86xx} \
338 ${LIST_4xx} \
Kim Phillips8c0c8932007-08-10 15:34:48 -0500339"
wdenk7ebf7442002-11-02 23:17:16 +0000340
Stefan Roese88fbf932010-04-15 16:07:28 +0200341# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
342# still using "ppc" instead of "powerpc"
343LIST_ppc=" \
344 ${LIST_powerpc} \
345"
346
wdenk7ebf7442002-11-02 23:17:16 +0000347#########################################################################
348## StrongARM Systems
349#########################################################################
350
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900351LIST_SA="$(targets_by_cpu sa1100)"
wdenk7ebf7442002-11-02 23:17:16 +0000352
353#########################################################################
Allen Martinc0171ca2012-08-29 11:08:59 +0000354## ARM7 Systems
355#########################################################################
356
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900357LIST_ARM7="$(targets_by_cpu arm720t)"
Allen Martinc0171ca2012-08-29 11:08:59 +0000358
359#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000360## ARM9 Systems
361#########################################################################
362
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900363LIST_ARM9="$(targets_by_cpu arm920t) \
364 $(targets_by_cpu arm926ejs) \
365 $(targets_by_cpu arm946es) \
wdenk7eaacc52003-08-29 22:00:43 +0000366"
wdenk7ebf7442002-11-02 23:17:16 +0000367
368#########################################################################
wdenkf8062712005-01-09 23:16:25 +0000369## ARM11 Systems
370#########################################################################
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900371LIST_ARM11="$(targets_by_cpu arm1136) \
372 $(targets_by_cpu arm1176) \
Allen Martinc0171ca2012-08-29 11:08:59 +0000373"
wdenkf8062712005-01-09 23:16:25 +0000374
375#########################################################################
Steve Sakoman6329a8f2010-06-17 21:50:01 -0700376## ARMV7 Systems
Dirk Behme2781f802009-01-27 18:19:12 +0100377#########################################################################
Dirk Behme1b787e32011-08-05 20:48:32 +0000378
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900379LIST_ARMV7="$(targets_by_cpu armv7)"
Dirk Behme2781f802009-01-27 18:19:12 +0100380
381#########################################################################
David Fengd6dfe972013-12-14 11:47:38 +0800382## ARMV8 Systems
383#########################################################################
384
385LIST_ARMV8="$(targets_by_cpu armv8)"
386
387#########################################################################
Jean-Christophe PLAGNIOL-VILLARD9a88fd12008-05-24 12:47:46 +0200388## AT91 Systems
389#########################################################################
390
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900391LIST_at91="$(targets_by_soc at91)"
Jean-Christophe PLAGNIOL-VILLARD9a88fd12008-05-24 12:47:46 +0200392
393#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000394## Xscale Systems
395#########################################################################
396
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900397LIST_pxa="$(targets_by_cpu pxa)"
wdenk7ebf7442002-11-02 23:17:16 +0000398
Wolfgang Denk66549bd2008-04-20 15:35:52 -0700399#########################################################################
Stefan Roese8ab8f2a2012-05-30 22:59:43 +0000400## SPEAr Systems
401#########################################################################
402
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900403LIST_spear="$(targets_by_soc spear)"
Stefan Roese8ab8f2a2012-05-30 22:59:43 +0000404
405#########################################################################
Wolfgang Denk66549bd2008-04-20 15:35:52 -0700406## ARM groups
407#########################################################################
wdenkbd1575f2003-10-14 19:43:55 +0000408
David Fengd6dfe972013-12-14 11:47:38 +0800409LIST_arm="$(targets_by_arch arm | \
410 for ARMV8_TARGET in $LIST_ARMV8; \
411 do sed "/$ARMV8_TARGET/d"; \
412 done) \
413"
wdenk7ebf7442002-11-02 23:17:16 +0000414
wdenkbb1b8262003-03-27 12:09:35 +0000415#########################################################################
Wolfgang Denkbc8c5002005-08-14 00:27:00 +0200416## MIPS Systems (default = big endian)
wdenkbb1b8262003-03-27 12:09:35 +0000417#########################################################################
418
Daniel Schwierzeck93ca7a72014-04-17 21:45:59 +0200419LIST_mips="$(targets_by_arch mips)"
Wolfgang Denkbc8c5002005-08-14 00:27:00 +0200420
Stefan Kristianssonc69cb3e2011-11-18 19:21:37 +0000421#########################################################################
422## OpenRISC Systems
423#########################################################################
424
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900425LIST_openrisc="$(targets_by_arch openrisc)"
Wolfgang Denkbc8c5002005-08-14 00:27:00 +0200426
427#########################################################################
Graeme Russcbfce1d2011-04-13 19:43:28 +1000428## x86 Systems
wdenkabda5ca2003-05-31 18:35:21 +0000429#########################################################################
430
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900431LIST_x86="$(targets_by_arch x86)"
wdenkabda5ca2003-05-31 18:35:21 +0000432
wdenk3be717f2004-01-03 19:43:48 +0000433#########################################################################
wdenkef3386f2004-10-10 21:27:30 +0000434## Nios-II Systems
435#########################################################################
436
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900437LIST_nios2="$(targets_by_arch nios2)"
wdenkef3386f2004-10-10 21:27:30 +0000438
439#########################################################################
wdenk20a61222004-07-10 23:48:41 +0000440## MicroBlaze Systems
441#########################################################################
442
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900443LIST_microblaze="$(targets_by_arch microblaze)"
wdenk20a61222004-07-10 23:48:41 +0000444
Zachary P. Landau1c3c0962006-01-26 17:38:46 -0500445#########################################################################
446## ColdFire Systems
447#########################################################################
448
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900449LIST_m68k="$(targets_by_arch m68k)"
Mike Frysinger6a9c0232011-09-25 19:27:19 +0000450LIST_coldfire=${LIST_m68k}
Zachary P. Landau1c3c0962006-01-26 17:38:46 -0500451
Wolfgang Denk994ad962006-10-24 14:42:37 +0200452#########################################################################
453## AVR32 Systems
454#########################################################################
455
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900456LIST_avr32="$(targets_by_arch avr32)"
Wolfgang Denk994ad962006-10-24 14:42:37 +0200457
Aubrey.Li450c23e2007-03-09 13:40:56 +0800458#########################################################################
459## Blackfin Systems
460#########################################################################
461
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900462LIST_blackfin="$(targets_by_arch blackfin)"
Aubrey.Li450c23e2007-03-09 13:40:56 +0800463
Jean-Christophe PLAGNIOL-VILLARDceee3382007-11-27 09:44:53 +0100464#########################################################################
465## SH Systems
466#########################################################################
467
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900468LIST_sh2="$(targets_by_cpu sh2)"
469LIST_sh3="$(targets_by_cpu sh3)"
470LIST_sh4="$(targets_by_cpu sh4)"
Jean-Christophe PLAGNIOL-VILLARDceee3382007-11-27 09:44:53 +0100471
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900472LIST_sh="$(targets_by_arch sh)"
Jean-Christophe PLAGNIOL-VILLARDceee3382007-11-27 09:44:53 +0100473
Daniel Hellstrom9d7c6b22008-03-28 09:47:00 +0100474#########################################################################
475## SPARC Systems
476#########################################################################
477
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900478LIST_sparc="$(targets_by_arch sparc)"
wdenk7ebf7442002-11-02 23:17:16 +0000479
Macpaul Line0eb35a2011-10-19 20:41:10 +0000480#########################################################################
481## NDS32 Systems
482#########################################################################
483
Masahiro Yamada9d3262b2013-10-21 11:11:28 +0900484LIST_nds32="$(targets_by_arch nds32)"
Macpaul Line0eb35a2011-10-19 20:41:10 +0000485
Alexey Brodkina2e5fda2014-02-04 12:56:20 +0400486#########################################################################
487## ARC Systems
488#########################################################################
489
490LIST_arc="$(targets_by_arch arc)"
491
wdenk7ebf7442002-11-02 23:17:16 +0000492#-----------------------------------------------------------------------
493
Marek Vasut4f21ade2012-03-05 15:10:51 +0000494get_target_location() {
495 local target=$1
496 local BOARD_NAME=""
497 local CONFIG_NAME=""
498 local board=""
499 local vendor=""
500
501 # Automatic mode
Masahiro Yamada4a3f1f42013-10-21 11:11:25 +0900502 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Marek Vasut4f21ade2012-03-05 15:10:51 +0000503 if [ -z "${line}" ] ; then echo "" ; return ; fi
504
505 set ${line}
506
Masahiro Yamada49e2c3c2014-07-30 14:08:21 +0900507 CONFIG_NAME="${7%_defconfig}"
Marek Vasut4f21ade2012-03-05 15:10:51 +0000508
Masahiro Yamada49e2c3c2014-07-30 14:08:21 +0900509 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
Marek Vasut4f21ade2012-03-05 15:10:51 +0000510
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200511 if [ $# -gt 5 ]; then
512 if [ "$6" = "-" ] ; then
513 board=${BOARD_NAME}
514 else
515 board="$6"
516 fi
Marek Vasut4f21ade2012-03-05 15:10:51 +0000517 fi
518
519 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200520 [ $# -gt 6 ] && [ "$8" != "-" ] && {
521 tmp="${8%:*}"
Marek Vasut4f21ade2012-03-05 15:10:51 +0000522 if [ "$tmp" ] ; then
523 CONFIG_NAME="$tmp"
524 fi
525 }
526
527 # Assign board directory to BOARDIR variable
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200528 if [ "${vendor}" == "-" ] ; then
Marek Vasut4f21ade2012-03-05 15:10:51 +0000529 BOARDDIR=${board}
530 else
531 BOARDDIR=${vendor}/${board}
532 fi
533
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200534 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
Marek Vasut4f21ade2012-03-05 15:10:51 +0000535}
536
537get_target_maintainers() {
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200538 local name=`echo $1 | cut -d : -f 3`
Marek Vasut4f21ade2012-03-05 15:10:51 +0000539
Masahiro Yamada4a3f1f42013-10-21 11:11:25 +0900540 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200541 if [ -z "${line}" ]; then
Marek Vasut4f21ade2012-03-05 15:10:51 +0000542 echo ""
543 return ;
544 fi
545
Albert ARIBAUD48e910f2013-09-11 15:52:51 +0200546 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
547 [ "$mails" == "-" ] && mails=""
548 echo "$mails"
Marek Vasut4f21ade2012-03-05 15:10:51 +0000549}
550
Allen Martin4b29aed2013-01-29 14:34:58 +0000551get_target_arch() {
552 local target=$1
553
Masahiro Yamada9bc275f2015-04-06 11:12:28 +0900554 awk '$7 == "'$target'" { print $2 }' boards.cfg
Allen Martin4b29aed2013-01-29 14:34:58 +0000555}
556
Marek Vasut4f21ade2012-03-05 15:10:51 +0000557list_target() {
558 if [ "$PRINT_MAINTS" != 'y' ] ; then
559 echo "$1"
560 return
561 fi
562
563 echo -n "$1:"
564
565 local loc=`get_target_location $1`
566
567 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
568
569 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
570
571 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
572
573 local dir=`echo ${loc} | cut -d ":" -f 2`
574 local cfg=`echo ${loc} | cut -d ":" -f 1`
575 local git_result=`git log --format=%aE board/${dir} \
576 include/configs/${cfg}.h | grep "@"`
577 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
578 head -n 3`
579 local git_result_top=`echo ${git_result} | tr " " "\n" | \
580 sort | uniq -c | sort -nr | head -n 3 | \
581 sed "s/^ \+[0-9]\+ \+//"`
582
583 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
584 sort -u | tr "\n" " " | sed "s/ $//" ;
585 else
586 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
587 sed "s/ $//" ;
588 fi
589
590 echo ""
591}
592
Andy Flemingaf1cc312012-04-24 19:33:51 +0000593# Each finished build will have a file called ${donep}${n},
594# where n is the index of the build. Each build
595# we've already noted as finished will have ${skipp}${n}.
596# The code managing the build process will use this information
597# to ensure that only BUILD_NBUILDS builds are in flight at once
598donep="${LOG_DIR}/._done_"
599skipp="${LOG_DIR}/._skip_"
600
Joe Hershberger1a268c22012-10-30 15:55:20 +0000601build_target_killed() {
602 echo "Aborted $target build."
603 # Remove the logs for this board since it was aborted
604 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
605 exit
606}
607
wdenk7ebf7442002-11-02 23:17:16 +0000608build_target() {
609 target=$1
Andy Flemingaf1cc312012-04-24 19:33:51 +0000610 build_idx=$2
611
Andy Fleming2f36f0a2012-05-09 20:36:28 +0000612 if [ "$ONLY_LIST" == 'y' ] ; then
613 list_target ${target}
614 return
615 fi
616
Andy Flemingaf1cc312012-04-24 19:33:51 +0000617 if [ $BUILD_MANY == 1 ] ; then
618 output_dir="${OUTPUT_PREFIX}/${target}"
619 mkdir -p "${output_dir}"
Joe Hershberger1a268c22012-10-30 15:55:20 +0000620 trap build_target_killed TERM
Andy Flemingaf1cc312012-04-24 19:33:51 +0000621 else
622 output_dir="${OUTPUT_PREFIX}"
623 fi
624
Allen Martin4b29aed2013-01-29 14:34:58 +0000625 target_arch=$(get_target_arch ${target})
York Sune493ee72013-03-22 07:37:03 +0000626 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
Allen Martin4b29aed2013-01-29 14:34:58 +0000627 if [ "${cross_toolchain}" ] ; then
Masahiro Yamada553b1fc2014-07-22 11:19:08 +0900628 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
Allen Martin4b29aed2013-01-29 14:34:58 +0000629 elif [ "${CROSS_COMPILE}" ] ; then
Masahiro Yamada553b1fc2014-07-22 11:19:08 +0900630 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
Allen Martin4b29aed2013-01-29 14:34:58 +0000631 else
Masahiro Yamada553b1fc2014-07-22 11:19:08 +0900632 MAKE=$GNU_MAKE
Allen Martin4b29aed2013-01-29 14:34:58 +0000633 fi
634
Masahiro Yamada59f15f22014-02-04 17:24:24 +0900635 if [ "${output_dir}" != "." ] ; then
636 MAKE="${MAKE} O=${output_dir}"
637 fi
638
Roger Meiere0a0e552014-08-20 22:10:29 +0200639 ${MAKE} mrproper >/dev/null
Masahiro Yamada49e2c3c2014-07-30 14:08:21 +0900640
641 echo "Building ${target} board..."
642 ${MAKE} -s ${target}_defconfig >/dev/null
Marian Balakowiczd62379d2006-09-01 19:49:50 +0200643
Kim Phillips568ea612012-09-27 14:57:34 +0000644 ${MAKE} ${JOBS} ${CHECK} all \
Andy Flemingaf1cc312012-04-24 19:33:51 +0000645 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
Peter Tysera5a27b92009-12-06 23:58:28 -0600646
647 # Check for 'make' errors
648 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
649 RC=1
650 fi
651
Joe Hershberger2e26ec12015-03-11 18:47:33 -0500652 OBJS=${output_dir}/u-boot
653 if [ -e ${output_dir}/spl/u-boot-spl ]; then
654 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
655 fi
656
657 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
658
Andy Flemingaf1cc312012-04-24 19:33:51 +0000659 if [ $BUILD_MANY == 1 ] ; then
Joe Hershberger1a268c22012-10-30 15:55:20 +0000660 trap - TERM
661
Masahiro Yamadad01ec132014-02-04 17:24:34 +0900662 ${MAKE} -s clean
Andy Flemingaf1cc312012-04-24 19:33:51 +0000663
664 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershberger67fc0592012-05-21 04:49:38 +0000665 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
Andy Flemingaf1cc312012-04-24 19:33:51 +0000666 else
667 rm ${LOG_DIR}/${target}.ERR
668 fi
Peter Tyser23240d22009-09-21 12:04:32 -0500669 else
Andy Flemingaf1cc312012-04-24 19:33:51 +0000670 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershberger67fc0592012-05-21 04:49:38 +0000671 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
672 : $(( ERR_CNT += 1 ))
673 ERR_LIST="${ERR_LIST} $target"
674 else
675 : $(( WRN_CNT += 1 ))
676 WRN_LIST="${WRN_LIST} $target"
677 fi
Andy Flemingaf1cc312012-04-24 19:33:51 +0000678 else
679 rm ${LOG_DIR}/${target}.ERR
680 fi
Peter Tyser23240d22009-09-21 12:04:32 -0500681 fi
682
Andy Flemingaf1cc312012-04-24 19:33:51 +0000683 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
684
Andy Flemingaf1cc312012-04-24 19:33:51 +0000685 touch "${donep}${build_idx}"
686}
687
688manage_builds() {
689 search_idx=${OLDEST_IDX}
Andy Fleming2f36f0a2012-05-09 20:36:28 +0000690 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
691
Andy Flemingaf1cc312012-04-24 19:33:51 +0000692 while true; do
693 if [ -e "${donep}${search_idx}" ] ; then
Andy Flemingaf1cc312012-04-24 19:33:51 +0000694 : $(( CURRENT_CNT-- ))
695 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
696 : $(( OLDEST_IDX++ ))
697
698 # Only want to count it once
699 rm -f "${donep}${search_idx}"
700 touch "${skipp}${search_idx}"
701 elif [ -e "${skipp}${search_idx}" ] ; then
702 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
703 : $(( OLDEST_IDX++ ))
704 fi
Andy Flemingaf1cc312012-04-24 19:33:51 +0000705 : $(( search_idx++ ))
706 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
Andy Flemingaf1cc312012-04-24 19:33:51 +0000707 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
708 search_idx=${OLDEST_IDX}
709 sleep 1
710 else
711 break
712 fi
713 fi
714 done
wdenk7ebf7442002-11-02 23:17:16 +0000715}
Andy Flemingaf1cc312012-04-24 19:33:51 +0000716
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400717build_targets() {
718 for t in "$@" ; do
719 # If a LIST_xxx var exists, use it. But avoid variable
720 # expansion in the eval when a board name contains certain
721 # characters that the shell interprets.
722 case ${t} in
723 *[-+=]*) list= ;;
724 *) list=$(eval echo '${LIST_'$t'}') ;;
725 esac
726 if [ -n "${list}" ] ; then
727 build_targets ${list}
728 else
Andy Flemingaf1cc312012-04-24 19:33:51 +0000729 : $((TOTAL_CNT += 1))
730 : $((CURRENT_CNT += 1))
731 rm -f "${donep}${TOTAL_CNT}"
732 rm -f "${skipp}${TOTAL_CNT}"
Joe Hershberger76c17542012-10-30 15:55:21 +0000733 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
734 : $((SKIP_CNT += 1))
735 touch "${donep}${TOTAL_CNT}"
736 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
737 : $((SKIP_CNT += 1))
738 touch "${donep}${TOTAL_CNT}"
Joe Hershberger8536b692012-05-21 04:49:37 +0000739 else
Joe Hershberger76c17542012-10-30 15:55:21 +0000740 if [ $BUILD_MANY == 1 ] ; then
741 build_target ${t} ${TOTAL_CNT} &
742 else
743 CUR_TGT="${t}"
744 build_target ${t} ${TOTAL_CNT}
745 CUR_TGT=''
746 fi
Joe Hershberger8536b692012-05-21 04:49:37 +0000747 fi
Andy Flemingaf1cc312012-04-24 19:33:51 +0000748 fi
749
750 # We maintain a running count of all the builds we have done.
751 # Each finished build will have a file called ${donep}${n},
752 # where n is the index of the build. Each build
753 # we've already noted as finished will have ${skipp}${n}.
754 # We track the current index via TOTAL_CNT, and the oldest
755 # index. When we exceed the maximum number of parallel builds,
756 # We look from oldest to current for builds that have completed,
757 # and update the current count and oldest index as appropriate.
758 # If we've gone through the entire list, wait a second, and
759 # reprocess the entire list until we find a build that has
760 # completed
761 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
762 manage_builds
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400763 fi
764 done
765}
wdenk7ebf7442002-11-02 23:17:16 +0000766
767#-----------------------------------------------------------------------
768
Andy Fleming2f36f0a2012-05-09 20:36:28 +0000769kill_children() {
Andreas Bießmann125a1712013-02-07 22:35:57 +0000770 local OS=$(uname -s)
771 local children=""
772 case "${OS}" in
773 "Darwin")
774 # Mac OS X is known to have BSD style ps
775 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
776 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
777 ;;
778 *)
779 # everything else tries the GNU style
780 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
781 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
782 ;;
783 esac
Joe Hershberger1a268c22012-10-30 15:55:20 +0000784
785 kill $children 2> /dev/null
786 wait $children 2> /dev/null
Andy Fleming2f36f0a2012-05-09 20:36:28 +0000787
788 exit
789}
790
Peter Tyser23240d22009-09-21 12:04:32 -0500791print_stats() {
Marek Vasutcc3e1cb2011-12-02 21:32:03 +0000792 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
Andy Flemingaf1cc312012-04-24 19:33:51 +0000793
Joe Hershberger1a268c22012-10-30 15:55:20 +0000794 # Only count boards that completed
795 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
796
Andy Flemingaf1cc312012-04-24 19:33:51 +0000797 rm -f ${donep}* ${skipp}*
798
799 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
Andy Flemingc594fe82012-08-08 14:12:30 +0000800 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
Joe Hershberger67fc0592012-05-21 04:49:38 +0000801 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
802 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
Andy Flemingc594fe82012-08-08 14:12:30 +0000803 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
Joe Hershberger67fc0592012-05-21 04:49:38 +0000804 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
805 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
Joe Hershberger1a268c22012-10-30 15:55:20 +0000806 else
807 # Remove the logs for any board that was interrupted
808 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
Andy Flemingaf1cc312012-04-24 19:33:51 +0000809 fi
810
Joe Hershberger76c17542012-10-30 15:55:21 +0000811 : $((TOTAL_CNT -= ${SKIP_CNT}))
Peter Tyser23240d22009-09-21 12:04:32 -0500812 echo ""
813 echo "--------------------- SUMMARY ----------------------------"
Joe Hershberger76c17542012-10-30 15:55:21 +0000814 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
815 echo "Boards skipped: ${SKIP_CNT}"
816 fi
Peter Tyser23240d22009-09-21 12:04:32 -0500817 echo "Boards compiled: ${TOTAL_CNT}"
818 if [ ${ERR_CNT} -gt 0 ] ; then
Joe Hershberger67fc0592012-05-21 04:49:38 +0000819 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
820 fi
821 if [ ${WRN_CNT} -gt 0 ] ; then
822 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
Peter Tyser23240d22009-09-21 12:04:32 -0500823 fi
824 echo "----------------------------------------------------------"
Peter Tysera5a27b92009-12-06 23:58:28 -0600825
Andy Fleming2f36f0a2012-05-09 20:36:28 +0000826 if [ $BUILD_MANY == 1 ] ; then
Joe Hershberger1a268c22012-10-30 15:55:20 +0000827 kill_children
Andy Fleming2f36f0a2012-05-09 20:36:28 +0000828 fi
829
Peter Tysera5a27b92009-12-06 23:58:28 -0600830 exit $RC
Peter Tyser23240d22009-09-21 12:04:32 -0500831}
wdenk7ebf7442002-11-02 23:17:16 +0000832
Peter Tyser23240d22009-09-21 12:04:32 -0500833#-----------------------------------------------------------------------
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400834
Wolfgang Denk7b74fec2010-10-17 12:26:48 +0200835# Build target groups selected by options, plus any command line args
836set -- ${SELECTED} "$@"
837# run PowerPC by default
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400838[ $# = 0 ] && set -- powerpc
Mike Frysingerb374bdb2010-08-19 13:05:06 -0400839build_targets "$@"
Andy Flemingaf1cc312012-04-24 19:33:51 +0000840wait